###Any queries about the below please email pauljwilson@wlv.ac.uk ######

#library(gamlss)
#library(poibin)
#library(VGAM)
N<-25000

h1<-function(t)  t*(1-exp(1/t-t))
h2a<-function(t)  t*(1-exp(-h1(t)))^2-(h1(t))^2*exp(-h1(t))
h2b<-function(t)  1-(h1(t)+1)*(exp(-h1(t)))

h2<-function(t)   h2a(t)/h2b(t)


N0<-MUW<-MUT<-rep(999,N)
for(j in 1:N){
X<-rpois(100,1)
n0<-length(X[X==0])
muw<-mean(X)
mut<-h2(mean(X[X>0]))

N0[j]<-n0
MUW[j]<-muw
MUT[j]<-mut

}

plot(N0,MUW,pch=1,ylim=c(0.4,1.6),xlim=c(15,55),col="grey1",xlab=expression(n[0]),ylab="Estimated Poisson Means",cex.lab=1.3)
par(new=TRUE)
plot(N0,MUT,pch=4,ylim=c(0.4,1.6),xlim=c(15,55),col="grey60",xlab="",ylab="")
abline(v=n*exp(-1),lty="dotted")
abline(h=1,lwd=2)


leg.names<-c("truncated sample", "whole sample")
legend("bottomleft", leg.names, lty=c(0,0) , lwd=c(2,2),col=c("grey60","grey1"),pch=c(1,4), cex=1.06)

