### This is the code for figure 5 of the Wilson-Einbeck Paper####
###Any queries about the code below please email
##  pauljwilson@wlv.ac.uk
rm(list=ls())
library(gamlss)
library(poibin)
library(VGAM)
nn<-10000 ## number of resamples
n<-100 ## the sample size, adjust as necessary
mu<-1 # adjust as required

h1<-function(t)  t*(1-exp(1/t-t))
h2a<-function(t)  t*(1-exp(-h1(t)))^2-(h1(t))^2*exp(-h1(t))
h2b<-function(t)  1-(h1(t)+1)*(exp(-h1(t)))

h2<-function(t)   h2a(t)/h2b(t)

#########h2 is Martin Ridout's approximation to h^{-1}(\hat\zeta)####

f<-function(t)  ifelse(t<2.07,0.7*(0.85^t),0.5) ## the parametric mixer

alpha<-0.05 ## level of significance




zmin<-  -1/(exp(mu)-1)  ###minimum possib ezero-modification parameter for given mu


AA<-c()
ZI<-c(seq(zmin,-0.05,0.05),-0.025,0,0.025,seq(0.05,0.9,0.05))

LQ<-length(ZI)
xx<-0
v<-0.8
par(mfrow=c(1,1))


#for(k in 1:length(MU)){


CCETFINALfix<-CCETTWOSTAGEafix<-CCETTWOSTAGEfix<-AS<-CCETFINAL2<-CCETFINAL<-CCETTWOSTAGEa<-CCETTWOSTAGE<-CCET<-rep(888,LQ)

#MU<-seq(0.5,6,0.5)
for(q in 1:length(ZI)){


 CETFINALfix<-CETTWOSTAGEafix<-CETTWOSTAGEfix<- S<-CETFINAL2<-CETFINAL<-CETP<-CETTWOSTAGEa<-CETTWOSTAGE<-rep(999,nn)


zi<-ZI[q]

print(zi)


for(j in 1:nn){

gg<-function(t) ifelse(t==0, zi+(1-zi)*dpois(t,mu),(1-zi)*dpois(t,mu)) ##ZMP density


ss<-seq(0,40,1)

ww<-rep(ss,round(gg(ss)*100000))

X<-sample(ww,n,replace=TRUE)

XO<-n0<-length(X[X==0])
#print(c(mu,n,n0))

y<-X[X>0]

mt<-mean(y)
muw<-mean(X)
a<-f(muw)
mum<-a*mean(X)+(1-a)*h2(mt)


p0<- exp(-muw)
S[j]<-((n0-n*p0)^2)/(n*p0*(1-p0)-n*muw*(p0^2)) ## score statistic
mfv<-dpois(xx,mum)
#
p1<-pbinom(XO,size=n, mfv)
XO1<-qbinom(1-p1,size=n, mfv)
p2<-pbinom(XO-1,size=n, mfv)
XO2<-qbinom(1-p2,size=n, mfv)

maxx<-max(XO,XO1)
minn<-min(XO,XO1)


maxx2<-max(XO-1,XO2)
minn2<-min(XO-1,XO2)

########################################FIXED###########################################

a<-2/3
mum<-a*mean(X)+(1-a)*h2(mt)



mfvfix<-dpois(0,mum)

p1<-pbinom(XO,size=n, mfvfix)
XO1<-qbinom(1-p1,size=n, mfvfix)
p2<-pbinom(XO-1,size=n, mfvfix)
XO2<-qbinom(1-p2,size=n, mfvfix)

maxxfix<-max(XO,XO1)
minnfix<-min(XO,XO1)


maxx2fix<-max(XO-1,XO2)
minn2fix<-min(XO-1,XO2)
########################################################################################
###########################LLR##########################

n0<-length(X[X==0])

mt<-mean(X[X>0])
mu1<-h2(mt)
zi1<-(n0-n*exp(-mu1))/(n-n*exp(-mu1))


gg7<-function(t) ifelse(t==0, zi1+(1-zi1)*dpois(t,mu1),(1-zi1)*dpois(t,mu1)) ##ZMP density

LLZ<-sum(log(gg7(X)))
LLP<-sum(log(dpois(X,mean(X))))


S[j]<- -2*(LLP-LLZ) ##the LR stat

############################
p1<-mfvfix
NN<-n*p1

ff1<-function(t) pbinom(t,size=n,prob=p1)-0.5*dbinom(t,size=n,prob=p1)



ff2<-function(t) ifelse(ff1(t)>0.5,1-ff1(t),ff1(t))


ff<-function(t)  2*ff2(t)
CETFINALfix[j]<-ff(XO)

p1<-mfv
NN<-n*p1

fff1<-function(t) pbinom(t,size=n,prob=p1)-0.5*dbinom(t,size=n,prob=p1)



fff2<-function(t) ifelse(fff1(t)>0.5,1-fff1(t),fff1(t))


g<-function(t) 2*n*p1-(t-0.5)
gf<-function(t) floor(g(t))

g<-function(t) 0.5-fff2(t)

dec<- function(t) g(t) -gf(t)

fff3<-function(t)  ifelse(t-0.5>NN, pbinom(gf(t),size=n,prob=p1)+dec(t)*dbinom(t+1,size=n,prob=p1), 1-(pbinom(gf(t),size=n, prob=p1)+dec(t)*dbinom(t+1,size=n, prob=p1)))



fff<-function(t) 2*fff2(t)
CETFINAL[j]<-fff(XO)


AA<-c(fff(XO),AA)
}


CCETFINAL[q]<-length(CETFINAL[CETFINAL<alpha])/nn
CCETFINALfix[q]<-length(CETFINALfix[CETFINALfix<alpha])/nn


LQ<-q
Sp<-1-pchisq(S,1)
SSp<-na.omit(Sp)
AS[q]<-  length(SSp[SSp<alpha])/length(SSp)


plot(ZI[1:LQ],CCETFINALfix[1:LQ],type="l",pch=4,col="grey5",cex=1.1,cex.lab=1.5, cex.main=1.5, lty="dashed",lwd=2,ylim=c(0,1), xlim=c(zmin,1),ylab="",xlab=expression(omega),main="POWER  Two Sided")
par(new=TRUE)
plot(ZI[1:LQ],CCETFINAL[1:LQ],type="l",pch=4,col="grey10",cex=1.1,cex.lab=1.5, cex.main=1.5, lty="dotted",lwd=2,ylim=c(0,1), xlim=c(zmin,1),ylab="",xlab=" ",main="")
par(new=TRUE)
plot(ZI[1:LQ],AS[1:LQ],col="grey8",lty="solid",type="l",pch=19,lwd=1,cex=1.1,ylim=c(0,1), xlim=c(zmin,1),ylab="",xlab=" ",main=" ",cex.lab=1.5, cex.main=1.5)

abline(h=0.8,lty="dotted",lwd=2)

abline(h=alpha,lty="dotted")
}

leg.names<-c("adaptive","fixed", "LR test")
legend(bottomright", leg.names, lty=c("dotted","dashed","solid") , lwd=c(2,2,2), cex=1.15)

