### This is the code for the  diagrams of figure 6  of the Wilson--Einbeck paper
rm(list=ls())
library(gamlss)
library(poibin)
library(VGAM)

alpha<-0.05 ## level of significance
nn<-250 ### number of resamamples, see note in section 4.4
n<-500 ## the sample size

h1<-function(t)  t*(1-exp(1/t-t))
h2a<-function(t)  t*(1-exp(-h1(t)))^2-(h1(t))^2*exp(-h1(t))
h2b<-function(t)  1-(h1(t)+1)*(exp(-h1(t)))
h2<-function(t)   h2a(t)/h2b(t)

#########h2 is Martin Ridout's approximation to h^{-1}(\hat\zeta), equation 4.4

f<-function(t)  ifelse(t<2.07,0.7*(0.85^t),0.5) ## the parametric mixer, equation 4.8

ZI<-c(0.0000000001,seq(0.05,0.95,0.05))
LQ<-length(ZI)

CCETFINAL<-CCETFINALfix<-CCETTWOSTAGEafix<-CCETTWOSTAGEfix<-LR<-CCETFINAL2<-CCETFINAL<-CCETTWOSTAGEa<-CCETTWOSTAGE<-CCET<-rep(888,LQ)

for(q in 1:length(ZI)){
  CETFINAL<-CETFINALfix<-CETTWOSTAGEafix<-CETTWOSTAGEfix<- LRT<-CETFINAL2<-CETFINAL<-CETP<-CETTWOSTAGEa<-CETTWOSTAGE<-rep(999,nn)

omega<-ZI[q]
print(mu)


for(j in 1:nn){

X<-rZIP(n,omega,mu)

XO<-n0<-length(X[X==0])

y<-X[X>0]

mt<-mean(y)
muw<-mean(X)
a<-f(muw)
mum<-a*mean(X)+(1-a)*h2(mt) # the hybrid estimator

p0<- exp(-mum)
mfv<-dpois(0,mum)

########################################FIXED###########################################

a<-2/3
mum<-a*mean(X)+(1-a)*h2(mt) # ther hybrid estimator
p0<- exp(-muw)
mfvfix<-dpois(0,mum)

########################################################################################
###########################Likelihood Ratio Test##########################

n0<-length(X[X==0])

LLP<-logLik(glm(X~1,family="poisson"))
LLZ<-logLik(gamlss(X~1,sigma.fo=~1,family="ZIP",trace=FALSE))

LRT[j]<- -2*(LLP-LLZ)

############################
p1<-mfvfix

CETTWOSTAGEfix[j]<-1-pbinom(XO,n,mfvfix)##the p-value of the Chistmas Eve Test
CETTWOSTAGEafix[j]<-1-pbinom(XO-1,n,mfvfix)##the p-value of the Chistmas Eve Test

CETFINALfix[j]<-CETTWOSTAGEfix[j]*1/2+CETTWOSTAGEafix[j]*1/2##the p-value of the Chistmas Eve Test


p1<-mfv
CETTWOSTAGE[j]<-1-pbinom(XO,n,mfv)##the p-value of the Chistmas Eve Test
CETTWOSTAGEa[j]<-1-pbinom(XO-1,n,mfv)##the p-value of the Chistmas Eve Test

CETFINAL[j]<-CETTWOSTAGE[j]*1/2+CETTWOSTAGEa[j]*1/2##the p-value of the Chistmas Eve Test


######## CETFINAL is the ``mid p-value''

}


CCETFINAL[q]<-length(CETFINAL[CETFINAL<alpha])/nn
CCETFINALfix[q]<-length(CETFINALfix[CETFINALfix<alpha])/nn


op<-function(t) ifelse(t<=0.5,0.5,(1+t)/2)
LRTp<-(1-op(pchisq(LRT,1)))


LR[q]<-  length(LRTp[LRTp<alpha])/length(LRTp)



}

MUI<-MU[1:q]
CETFIX<-CCETFINALfix[1:q]
CETVAR<-CCETFINAL[1:q]
LR<-LR[1:q]
a500os<-data.frame(MUI,CETFIX,CETVAR,LR)

plot(a500os$MUI,a500os$CETFIX,type="l",pch=4,col="grey5",cex=1.1,cex.lab=1.5, cex.main=1.5, lty="dashed",lwd=2,ylim=c(0,0.1), xlim=c(0,4.5),ylab="",xlab=expression(mu),main="n=500  One Sided",cex.lab=1.4)
par(new=TRUE)
plot(a500os$MUI,a500os$CETVAR,type="l",pch=4,col="grey10",cex=1.1,cex.lab=1.5, cex.main=1.5, lty="dotted",lwd=2,ylim=c(0,0.1), xlim=c(0,4.5),ylab="",xlab=" ",main="")
par(new=TRUE)
plot(a500os$MUI,a500os$LR,col="grey8",lty="solid",type="l",pch=19,lwd=1,cex=1.1,ylim=c(0,0.1), xlim=c(0,4.5),ylab="",xlab=" ",main=" ",cex.lab=1.5, cex.main=1.5)

abline(h=alpha,lty="dotted")

#leg.names<-c("adaptive", "fixed",  "LR test")
#legend("bottomright", leg.names, lty=c("dotted","dashed","solid") , lwd=c(2,2,2),col=c("grey5","grey10","grey15"), cex=1.26)

