##This produces  a colour version of Figure 3 left of the Wilson-Einbeck Paper##
library(poibin)


####Martin Ridout's function####
h1<-function(t)  t*(1-exp(1/t-t))
h2a<-function(t)  t*(1-exp(-h1(t)))^2-(h1(t))^2*exp(-h1(t))
h2b<-function(t)  1-(h1(t)+1)*(exp(-h1(t)))

h2<-function(t)   h2a(t)/h2b(t)
###################################################
n<-500## sample size
nn<-25000# number of resamples per mu


alpha<-0.05

MU<-c(0.5,1,2,3,4,5)
LQ<-length(MU)

H<-seq(0.05,0.95,0.01)


POWERS<-matrix(999, nrow=length(H),ncol=length(MU))
for(i in 1:length(MU)){
mu<-MU[i]
print(mu)
for(h in 1:length(H)){
  CETTWOSTAGE<- CETTWOSTAGE2<- CETFINAL2<-CETTWOSTAGEa2<-rep(999,nn)
  



for(j in 1:nn){

  X<-rpois(n,mu)
XO<-length(X[X==0])



y<-X[X>0]

mt<-mean(y)
muw<-mean(X)

af<-H[h]

mumfix<-af*muw+(1-af)*h2(mt)

mfv2<-dpois(0,mumfix)



###############for fixed h #######################
p1<-pbinom(XO,size=n, mfv2)
XO1<-qbinom(1-p1,size=n, mfv2)
p2<-pbinom(XO-1,size=n, mfv2)
XO2<-qbinom(1-p2,size=n, mfv2)

maxx<-max(XO,XO1)
minn<-min(XO,XO1)


maxx2<-max(XO-1,XO2)
minn2<-min(XO-1,XO2)

CETTWOSTAGE2[j]<-1-pbinom(XO-1,n,mfv2)
CETTWOSTAGEa2[j]<-1-pbinom(XO,n,mfv2)

CETTWOSTAGE[j]<-CETTWOSTAGE2[j]*1/2+CETTWOSTAGEa2[j]*1/2##the mid p-value of the  Test
#########################################################################



}


POWERS[h,i]<-length(CETTWOSTAGE[CETTWOSTAGE<alpha])/nn
#print(CPOWERS)
}

  
}

#}


  plot(H,POWERS[,1],type="l",pch=4,col="red",cex=0.6,lty="solid",lwd=2,ylim=c(0,0.2), xlim=c(0.0,1),ylab="OBSERVED ATTAINMENT",xlab="h",main="Nominal Attainment =0.05")
par(new=TRUE)
plot(H,POWERS[,2],type="l",pch=4,col="orange",cex=0.6,lty="solid",lwd=2,ylim=c(0,0.2), xlim=c(0.0,1),ylab="",xlab="",main="")
par(new=TRUE)
plot(H,POWERS[,3],type="l",pch=4,col="brown",cex=0.6,lty="solid",lwd=2,ylim=c(0,0.2), xlim=c(0.0,1),ylab="",xlab="",main="")
par(new=TRUE)
plot(H,POWERS[,4],type="l",pch=4,col="green",cex=0.6,lty="solid",lwd=2,ylim=c(0,0.2), xlim=c(0.0,1),ylab="",xlab="",main="")
par(new=TRUE)
plot(H,POWERS[,5],type="l",pch=4,col="blue",cex=0.6,lty="solid",lwd=2,ylim=c(0,0.2), xlim=c(0.0,1),ylab="",xlab="",main="")
par(new=TRUE)
plot(H,POWERS[,6],type="l",pch=4,col="purple",cex=0.6,lty="solid",lwd=2,ylim=c(0,0.2), xlim=c(0.0,1),ylab="",xlab="",main="")
par(new=TRUE)
plot(H,CPOWERS[,7],type="l",pch=4,col="violet",cex=0.6,lty="solid",lwd=2,ylim=c(0,0.2), xlim=c(0.4,0.8),ylab="",xlab="",main="")
par(new=TRUE)
plot(H,CPOWERS[,8],type="l",pch=4,col="black",cex=0.6,lty="solid",lwd=2,ylim=c(0,0.2), xlim=c(0.4,0.8),ylab="",xlab="",main="")
par(new=TRUE)
plot(H,CPOWERS[,9],type="l",pch=4,col="grey40",cex=0.6,lty="solid",lwd=2,ylim=c(0,0.2), xlim=c(0.4,0.8),ylab="",xlab="",main="")
abline(h=0.05,lty="dotted")
abline(v=0.666,lty="dotted")

leg.names<-c("mu=0.5", "mu=1.0", "mu=2.0", "mu=3.0","mu=4.0", "mu=5.0")
legend("topright", leg.names,  , lwd=c(2,2,2,2,2,2), col=c("red","orange","brown","green","blue", "purple"),cex=1.00)


F1<-abs(POWERS-0.05)
F2<-data.frame(H,F1)

OPT<-rep(999,4)

for(ii in 2:5){
OPT[ii-1]<-median(F2$H[F2[,ii]==min(F2[,ii])])
}
OPT
