### This is the code for the left hand diagrams figure 4 of the Wilson--Einbeck paper
rm(list=ls())
library(gamlss)
library(poibin)
library(VGAM)


N2<-25000#the number of resamples, see note in Section 4.4

n<-500 ## the sample size


h1<-function(t)  t*(1-exp(1/t-t))
h2a<-function(t)  t*(1-exp(-h1(t)))^2-(h1(t))^2*exp(-h1(t))
h2b<-function(t)  1-(h1(t)+1)*(exp(-h1(t)))
h2<-function(t)   h2a(t)/h2b(t)

#########h2 is Martin Ridout's approximation to h^{-1}(\hat\zeta), equation 4.4 of the paper####

f<-function(t)  ifelse(t<2.07,0.7*(0.85^t),0.5) ## the parametric mixer, equation 4.8

alpha<-0.05 ## level of significance

MU<-seq(0.5,4.5,0.5) ## Poisson Parameter values
LQ<-length(MU)

CCETFINAL<-CCETFINALfix<-CCETTWOSTAGEafix<-CCETTWOSTAGEfix<-LR<-CCETFINAL2<-CCETFINAL<-CCETTWOSTAGEa<-CCETTWOSTAGE<-CCET<-rep(888,LQ)


for(q in 1:length(MU)){

nn<-N2
LRT<- CETFINALfix<-CETTWOSTAGEafix<-CETTWOSTAGEfix<-CETFINAL2<-CETFINAL<-CETP<-CETTWOSTAGEa<-CETTWOSTAGE<-rep(999,nn)

mu<-MU[q]

print(mu)

for(j in 1:nn){

X<-rpois(n,mu)
XO<-n0<-length(X[X==0]) # the number of observed zeros

muw<-mean(X)
########################################################################################
###########################Likelihood Ratio Test##########################



mt<-mean(X[X>0])
mu1<-h2(mt) # the estimator of the Poisson parameter from the positive observations
zi1<-(n0-n*exp(-mu1))/(n-n*exp(-mu1)) # the  estimate of the zero-inflation parameter

gg7<-function(t) ifelse(t==0, zi1+(1-zi1)*dpois(t,mu1),(1-zi1)*dpois(t,mu1)) ##ZMP density

LLZ<-sum(log(gg7(X)))    ###log-likelihood of the ZIP model
LLP<-sum(log(dpois(X,mean(X)))) ## log-likelihood of the Poisson model


LRT[j]<- -2*(LLP-LLZ)

############################FIXED#################
a<-2/3
mumfix<-a*mean(X)+(1-a)*h2(mt)



mfvfix<-dpois(0,mumfix)

p1<-mfvfix

ff1<-function(t) pbinom(t,size=n,prob=p1)-0.5*dbinom(t,size=n,prob=p1)
ff2<-function(t) ifelse(ff1(t)>0.5,1-ff1(t),ff1(t))

ff<-function(t)  2*ff2(t)

CETFINALfix[j]<-ff(XO)
########################VAR#########################

a<-f(muw)
mum<-a*mean(X)+(1-a)*h2(mt)


p1<-dpois(0,mum)

#p1<-mfv
NN<-n*p1
#NN<-0.5
fff1<-function(t) pbinom(t,size=n,prob=p1)-0.5*dbinom(t,size=n,prob=p1)

fff2<-function(t) ifelse(fff1(t)>0.5,1-fff1(t),fff1(t))

fff<-function(t) 2*fff2(t)  
CETFINAL[j]<-fff(XO)


}


CCETFINAL[q]<-length(CETFINAL[CETFINAL<alpha])/nn
CCETFINALfix[q]<-length(CETFINALfix[CETFINALfix<alpha])/nn


LRTp<-1-pchisq(LRT,1)

LR[q]<-  length(LRTp[LRTp<alpha])/length(LRTp)
}



LLLR<-LR

plot(MU[1:LQ],CCETFINALfix[1:LQ],type="l",pch=4,col="grey5",cex=1.1,cex.lab=1.5, cex.main=1.5, lty="dashed",lwd=2,ylim=c(0,0.1), xlim=c(0,4.5),ylab="",xlab=expression(mu),main="n=500  Two Sided",cex.lab=1.4)
par(new=TRUE)
plot(MU[1:LQ],CCETFINAL[1:LQ],type="l",pch=4,col="grey10",cex=1.1,cex.lab=1.5, cex.main=1.5, lty="dotted",lwd=2,ylim=c(0,0.1), xlim=c(0,4.5),ylab="",xlab=" ",main="")
par(new=TRUE)
plot(MU[1:LQ],LR[1:LQ],col="grey8",lty="solid",type="l",pch=19,lwd=1,cex=1.1,ylim=c(0,0.1), xlim=c(0,4.5),ylab="",xlab=" ",main=" ",cex.lab=1.5, cex.main=1.5)

abline(h=alpha,lty="dotted")


leg.names<-c("adaptive", "fixed",  "LR test")
legend("bottomright", leg.names, lty=c("dotted","dashed","solid") , lwd=c(2,2,2),col=c("grey5","grey10","grey15"), cex=1.2)
