##This is a colour version of Figure 3 Left#########

library(gamlss)
library(poibin)
library(VGAM)
n<-500  ## the sample size

h1<-function(t)  t*(1-exp(1/t-t))
h2a<-function(t)  t*(1-exp(-h1(t)))^2-(h1(t))^2*exp(-h1(t))
h2b<-function(t)  1-(h1(t)+1)*(exp(-h1(t)))

h2<-function(t)   h2a(t)/h2b(t)

#########h2 is Martin Ridout's approximation to h^{-1}(\hat\zeta)####

f<-function(t)  ifelse(t<2.07,0.7*(0.85^t),0.5) ## the parametric mixer

alpha<-0.05 ## level of significance
nn<-50 ### number of resamples

MU<-c(1,2,3)

POWERS<-ZZ<-matrix(999,ncol=length(MU),nrow=50)

for(jj in 1:length(MU)){

  mu<-MU[jj]
print(mu)
zmin<-  -1/(exp(mu)-1)  ###minimum possible zero-modification parameter for given mu



ZI<-c(seq(zmin,-0.0001,0.05),0,seq(0.05,0.9,0.05))
LQ<-length(ZI)
ZZ[1:length(ZI),jj]<-ZI
xx<-0
v<-0.8
par(mfrow=c(1,1))


#for(k in 1:length(MU)){


CCETFINALF<-CCETTWOSTAGEaF<-AS<-CCETFINAL2<-CCETFINAL<-CCETTWOSTAGEa<-CCETTWOSTAGE<-CCET<-rep(888,LQ)

#MU<-seq(0.5,6,0.5)
for(q in 1:length(ZI)){
  CETTWOSTAGEF<-CETFINAL2F<-CETFINALF<-CETPF<-CETTWOSTAGEaF<- S<-CETFINAL2<-CETFINAL<-CETP<-CETTWOSTAGEa<-CETTWOSTAGE<-rep(999,nn)


zi<-ZI[q]
#print(zi)


for(j in 1:nn){


gg<-function(t) ifelse(t==0, zi+(1-zi)*dpois(t,mu),(1-zi)*dpois(t,mu)) ##ZMP density


ss<-seq(0,40,1)

ww<-rep(ss,round(gg(ss)*100000))

X<-sample(ww,n,replace=TRUE)

XO<-n0<-length(X[X==0])
#print(c(mu,n,n0))

y<-X[X>0]

mt<-mean(y)
muw<-mean(X)


############################adaptive#############################
#a<-f(muw)
A<-2/3
mum<-a*mean(X)+(1-a)*h2(mt)


p0<- exp(-muw)
S[j]<-((n0-n*p0)^2)/(n*p0*(1-p0)-n*muw*(p0^2)) ## score statistic
mfv<-dpois(xx,mum)
#
p1<-pbinom(XO,size=n, mfv)
XO1<-qbinom(1-p1,size=n, mfv)
p2<-pbinom(XO-1,size=n, mfv)
XO2<-qbinom(1-p2,size=n, mfv)

maxx<-max(XO,XO1)
minn<-min(XO,XO1)


maxx2<-max(XO-1,XO2)
minn2<-min(XO-1,XO2)

CETTWOSTAGE[j]<-1-pbinom(maxx,n,mfv)+pbinom(minn,n,mfv)##the p-value of the Chistmas Eve Test
CETTWOSTAGEa[j]<-1-pbinom(maxx2,n,mfv)+pbinom(minn2,n,mfv)##the p-value of the Chistmas Eve Test

CETFINAL[j]<-CETTWOSTAGE[j]*1/2+CETTWOSTAGEa[j]*1/2##the p-value of the Chistmas Eve Test

######## CETFINAL is the ``mid p-value''
####################################################################################################
###################################FIXED############################################################
####################################################################################################
#a<-2/3

#mumf<-a*mean(X)+(1-a)*h2(mt)

#
#mfvf<-dpois(xx,mumf)
#
#p1<-pbinom(XO,size=n, mfvf)
#XO1<-qbinom(1-p1,size=n, mfvf)
#p2<-pbinom(XO-1,size=n, mfvf)
#XO2<-qbinom(1-p2,size=n, mfvf)

#maxx<-max(XO,XO1)
#minn<-min(XO,XO1)


#maxx2<-max(XO-1,XO2)
#minn2<-min(XO-1,XO2)

#CETTWOSTAGEF[j]<-1-pbinom(maxx,n,mfvf)+pbinom(minn,n,mfvf)##the p-value of the Chistmas Eve Test
#CETTWOSTAGEaF[j]<-1-pbinom(maxx2,n,mfvf)+pbinom(minn2,n,mfvf)##the p-value of the Chistmas Eve Test

#CETFINALF[j]<-CETTWOSTAGEF[j]*1/2+CETTWOSTAGEaF[j]*1/2##the p-value of the Chistmas Eve Test


}


CCETFINAL[q]<-length(CETFINAL[CETFINAL<alpha])/nn

CCETFINALF[q]<-length(CETFINALF[CETFINALF<alpha])/nn


LQ<-q

plot(ZI[1:LQ],CCETFINAL[1:LQ],type="l",pch=4,col=mu*2,cex=1.0, lty="solid",lwd=2,ylim=c(0,1), xlim=c(-1.6,1),ylab="",xlab="Zero Modification Parameter",main="POWER, mu=2.0, n=30 \n Two-Sided")
par(new=TRUE)
#plot(ZI[1:LQ],AS[1:LQ],col="grey18",lty="solid",type="l",pch=19,lwd=1,cex=1.0,ylim=c(0,1), xlim=c(zmin,1),ylab="",xlab=" ",main=" ")
#par(new=TRUE)
#plot(ZI[1:LQ],CCETFINALF[1:LQ],type="l",pch=4,col="grey38",cex=1.0,lty="dashed",lwd=2,ylim=c(0,1), xlim=c(zmin,1),ylab="",xlab=" ",main="")


abline(h=0.8,lty="dotted",lwd=2)

abline(h=alpha,lty="dotted")

}


POWERS[1:length(CCETFINAL[1:LQ]),jj]<-CCETFINAL[1:LQ]

}
#leg.names<-c("adaptive","fixed",  "score test")
#legend(0.31, 0.089, leg.names, lty=c("dotted","solid","dashed") ,col=c("grey3","grey18", "grey38") ,lwd=c(2,2,2), cex=0.8)


ZZ1<-ZZ[,1]
ZZ2<-ZZ[,2]
ZZ3<-ZZ[,3]
ZZ4<-ZZ[,4]
ZZ5<-ZZ[,5]
ZZ6<-ZZ[,6]

POWERS1<-POWERS[,1]
POWERS2<-POWERS[,2]
POWERS3<-POWERS[,3]
POWERS4<-POWERS[,4]
POWERS5<-POWERS[,5]
POWERS6<-POWERS[,6]


plot(ZZ1[ZZ1<999],POWERS1[POWERS1<999],type="l",col="red",ylim=c(0,1),xlim=c(-1.6,1),xlab="ZERO MODIFICATION PARAMETER",ylab="",main="POWER, h=2/3")
par(new=TRUE)
plot(ZZ2[ZZ2<999],POWERS2[POWERS2<999],type="l",col="orange",ylim=c(0,1),xlim=c(-1.6,1),xlab="",ylab="")
par(new=TRUE)
plot(ZZ3[ZZ3<999],POWERS3[POWERS3<999],type="l",col="brown",ylim=c(0,1),xlim=c(-1.6,1),xlab="",ylab="")
par(new=TRUE)
plot(ZZ4[ZZ4<999],POWERS4[POWERS4<999],type="l",col="green",ylim=c(0,1),xlim=c(-1.6,1),xlab="",ylab="")
par(new=TRUE)
plot(ZZ5[ZZ5<999],POWERS5[POWERS5<999],type="l",col="blue",ylim=c(0,1),xlim=c(-1.6,1),xlab="",ylab="")
par(new=TRUE)
plot(ZZ6[ZZ6<999],POWERS6[POWERS6<999],type="l",col="purple",ylim=c(0,1),xlim=c(-1.6,1),xlab="",ylab="")
abline(h=0.05,lty="dotted")
abline(h=0.80,lty="dotted")

leg.names<-c("mu=0.5", "mu=1.0", "mu=2.0", "mu=3.0","mu=4.0", "mu=5.0")
legend(-1.6, .25, leg.names,  , lwd=c(2,2,2,2,2,2), col=c("red","orange","brown","green","blue", "purple"),cex=1.00)

