###If you have any queries about this code please email
### pauljwilson@wlv.ac.uk

library(gamlss)
library(VGAM)
library(poibin)

f<-function(t)  ifelse(t<2.07,0.7*(0.85^t),0.5)


h1<-function(t)  t*(1-exp(1/t-t))
h2a<-function(t)  t*(1-exp(-h1(t)))^2-(h1(t))^2*exp(-h1(t))
h2b<-function(t)  1-(h1(t)+1)*(exp(-h1(t)))

h2<-function(t)   h2a(t)/h2b(t)



y1<-c(rep(0,144),rep(1,91),rep(2,32),rep(3,11),rep(4,2))
##the horse kicks data

n<-length(y1)
n0<-length(y1[y1==0])

y<-y1[y1>0]

muw<-mean(y1)
mut<-h2(mean(y))

#a<-f(muw) (adaptive)
a<-2/3  (fixed)  (a is referred to as "h" in the paper)
mu<-a*muw+(1-a)*mut

mfv<-dpois(0,mu)

pvaluepois1<-0.5*(1-pbinom(144,n,mfv)+1-pbinom(143,n,prob=mfv))
## this is the RHS p-value corresponding to an identity link
##the left hand p-value is 1-right hand
pvaluepois2<-0.5*pbinom(126,n,mfv)+0.5*pbinom(127,n,mfv)
pvaluepois2+pvaluepois1  ##two-side p-value (identity link)


###note: there are various methods for determining 
###the p-value coesponding to a two sided test with a discrete
###tests statistic, other values to the above are possible
###but they all are approximately the same in all but pathological examples.
##the most appropriate form for this test is to be researched!

lower<-qbinom(c(0.05,0.95),n,mfv)[2]-1
upper<-qbinom(c(0.05,0.95),n,mfv)[2]

aa<-pbinom(upper,n,mfv)
bb<-pbinom(lower,n,mfv)

k<-(0.95-aa)/(bb-aa)

a1<-k*lower+(1-k)*upper


lower<-qbinom(c(0.05,0.95),n,mfv)[1]-1
upper<-qbinom(c(0.05,0.95),n,mfv)[1]

aa<-pbinom(upper,n,mfv)
bb<-pbinom(lower,n,mfv)

k<-(0.05-aa)/(bb-aa)

a2<-k*lower+(1-k)*upper


c(a2,a1) ## is the MQI


###############################################################
##There are various ways to estimate the poisson parameter with a log link
## one such is

modp<-glm(y1~1,family="poisson")
m1 <- vglm(y~1, family = pospoisson())


mu<-a*fitted(modp)[1]+ (1-a)*h2(fitted(m1)[1])

#In the abscence of covariates the resullts using identity or log-links 
#will be the same.
#########################################

##p-values of the LR test.

1-pchisq(2*(logLik(gamlss(y1~1,family="ZIP"))-logLik(glm(y1~1,family="poisson"))),1)
