###If you have any queries concerning this code please email
### Pauljwilson@wlv.ac.uk


#library(gamlss)
#library(VGAM)
#library(poibin)


h1<-function(t)  t*(1-exp(1/t-t))
h2a<-function(t)  t*(1-exp(-h1(t)))^2-(h1(t))^2*exp(-h1(t))
h2b<-function(t)  1-(h1(t)+1)*(exp(-h1(t)))

h2<-function(t)   h2a(t)/h2b(t)

#########h2 is Martin Ridout's approximation to h^{-1}(\hat\zeta)####

f<-function(t)  ifelse(t<2.07,0.7*(0.85^t),0.5) ## the parametric mixer

########### Data A1 ##################################

dose<-c(0,0.25,0.75,1,1.5,2.5,3,4.5)
freq<-matrix(c(2591,2185,2550,2231,1712,1196,1070,895,1,8,44,54,96,123,320,360,0,0,1,2,3,7,41,110,0,0,0,0,0,1,6,25,0,0,0,0,0,0,1,5,0,0,0,0,
               0,0,0,1),8,6)
d<-dim(freq)[1]
ndic<-dim(freq)[2]-1
ncel<-rowSums(freq)
X<-as.vector(freq%*%(0:ndic))
dic<-dosevec<-numeric()
for(i in 1:d){
  for (j in 0:ndic){
    dic<-c(dic,rep(j,freq[i,j+1]))
    dosevec<-c(dosevec,rep(dose[i],freq[i,j+1]))
  }}
datavecA1<-data.frame(dic,dosevec,dosevec2=dosevec^2) 
dataggrA1<-data.frame(X,ncel,dose,dose2=dose^2)

attach(datavecA1)
dicb<-datavecA1$dic[dic>0]
dosevecb<-dosevec[dic>0]
dosevecb2<-dosevecb^2

mod<-glm(dic~dosevec+dosevec2,family=poisson,data=datavecA1)

m1 <- vglm(dicb~dosevecb+dosevecb2, family = pospoisson())


DM<-as.matrix(data.frame(1,datavecA1[,2:3]))

cm1a<-coefficients(m1)

cm1<-exp(DM%*%cm1a)
X<-dic

XO<-length(X[X==0])

h<-f(mod$fitted.values)
mfv<-dpois(0,mod$fitted.values*h+cm1*(1-h))##for Poisson model


1-ppoibin(XO,pp=mfv)##the p-value

QI<-qpoibin(c(0.05,0.95),pp=mfv)

####determining the MQI###
lower<-QI[2]-1
upper<-QI[2]

aa<-ppoibin(upper,mfv)
bb<-ppoibin(lower,mfv)

k<-(0.95-aa)/(bb-aa)

a1<-k*lower+(1-k)*upper ##the upper limit of MQI


lower<-QI[1]-1
upper<-QI[1]

aa<-ppoibin(upper,pp=mfv)
bb<-ppoibin(lower,pp=mfv)

k<-(0.05-aa)/(bb-aa)

a2<-k*lower+(1-k)*upper


c(a2,a1) ## is the MQI

##Data A3#########################
dose<-1:5
freq<-matrix(c(1715,638,247,99,48,268,298,225,129,88,15,56,85,92,97,2,8,37,52,99,0,0,6,21,36,0,0,0,5,25,0,0,0,2,5,0,0,0,0,2),5,8)
d<-dim(freq)[1]
ndic<-dim(freq)[2]-1
ncel<-rowSums(freq)
X<-as.vector(freq%*%(0:ndic))
dic<-dosevec<-numeric()
for(i in 1:d){
  for (j in 0:ndic){
    dic<-c(dic,rep(j,freq[i,j+1]))
    dosevec<-c(dosevec,rep(dose[i],freq[i,j+1]))
  }}
datavecA3<-data.frame(dic,dosevec,dosevec2=dosevec^2) 
dataggrA3<-data.frame(X,ncel,dose,dose2=dose^2)

dicb<-datavecA3$dic[dic>0]
dosevecb<-datavecA3$dosevec[dic>0]
dosevecb2<-dosevecb^2

mod<-glm(dic~dosevec+dosevec2,family=poisson,data=datavecA3)

m1 <- vglm(dicb~dosevecb+dosevecb2, family = pospoisson())


DM<-as.matrix(data.frame(1,datavecA3[,2:3]))

cm1a<-coefficients(m1)

cm1<-exp(DM%*%cm1a)
X<-dic

XO<-length(X[X==0])

h<-f(mod$fitted.values)
mfv<-dpois(0,mod$fitted.values*h+cm1*(1-h))##for Poisson model

1-ppoibin(XO,mfv)

QI<-qpoibin(c(0.05,0.95),pp=mfv)

####determining the MQI###
lower<-QI[2]-1
upper<-QI[2]

aa<-ppoibin(upper,mfv)
bb<-ppoibin(lower,mfv)

k<-(0.95-aa)/(bb-aa)

a1<-k*lower+(1-k)*upper ##the upper limit of MQI


lower<-QI[1]-1
upper<-QI[1]

aa<-ppoibin(upper,pp=mfv)
bb<-ppoibin(lower,pp=mfv)

k<-(0.05-aa)/(bb-aa)

a2<-k*lower+(1-k)*upper


c(a2,a1) ## is the MQI

####Data B1########################

dose<-c(0,0.092,0.12,0.205,0.3,0.405,0.6,0.82,1.2,1.6)
freq<-matrix(c(1999,737,1438, 1300,471,437,473,253,92, 80,1,16,55,104,73,66,119,99,55,49,0,0,5,14,15,15,34,38,
               27,26,0,0,2,2,1,1,3,17,11,13,0,0,0,0,0,1,2,5,4,5,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0),10,8)
d<-dim(freq)[1]
ndic<-dim(freq)[2]-1
ncel<-rowSums(freq)
X<-as.vector(freq%*%(0:ndic))
dic<-dosevec<-numeric()
for(i in 1:d){
  for (j in 0:ndic){
    dic<-c(dic,rep(j,freq[i,j+1]))
    dosevec<-c(dosevec,rep(dose[i],freq[i,j+1]))
  }}

datavecB1<-data.frame(dic,dosevec,dosevec2=dosevec^2) 

dicb<-datavecB1$dic[dic>0]
dosevecb<-datavecB1$dosevec[dic>0]
dosevecb2<-dosevecb^2

mod<-glm(dic~dosevec+dosevec2,family=poisson,data=datavecB1)

m1 <- vglm(dicb~dosevecb+dosevecb2, family = pospoisson(),data=datavecB1)


DM<-as.matrix(data.frame(1,datavecB1[,2:3]))

cm1a<-coefficients(m1)

cm1<-exp(DM%*%cm1a)
X<-dic

XO<-length(X[X==0])

h<-f(mod$fitted.values)
mfv<-dpois(0,mod$fitted.values*h+cm1*(1-h))##for Poisson model

1-ppoibin(XO,mfv)

QI<-qpoibin(c(0.05,0.95),pp=mfv)

####determining the MQI###
lower<-QI[2]-1
upper<-QI[2]

aa<-ppoibin(upper,mfv)
bb<-ppoibin(lower,mfv)

k<-(0.95-aa)/(bb-aa)

a1<-k*lower+(1-k)*upper ##the upper limit of MQI


lower<-QI[1]-1
upper<-QI[1]

aa<-ppoibin(upper,pp=mfv)
bb<-ppoibin(lower,pp=mfv)

k<-(0.05-aa)/(bb-aa)

a2<-k*lower+(1-k)*upper


c(a2,a1) ## is the MQI

####

##### Dataset (C1)
dose<-1:5
freq<-matrix(c(2713,1302,1116,929,726,78,71,46,18,17,8,22,28,14,18,0,5,7,22,12,1,0,2,13,9,0,0,1,2,13,0,0,0,0,1,0,0,0,1,4,0,0,0,1,0),5,9)
d<-dim(freq)[1]
ndic<-dim(freq)[2]-1
ncel<-rowSums(freq)
X<-as.vector(freq%*%(0:ndic))
dic<-dosevec<-numeric()
for(i in 1:d){
  for (j in 0:ndic){
    dic<-c(dic,rep(j,freq[i,j+1]))
    dosevec<-c(dosevec,rep(dose[i],freq[i,j+1]))
  }}
datavecC1<-data.frame(dic,dosevec,dosevec2=dosevec^2) 

dicb<-datavecC1$dic[dic>0]
dosevecb<-datavecC1$dosevec[dic>0]
dosevecb2<-dosevecb^2

mod<-glm(dic~dosevec+dosevec2,family=poisson,data=datavecC1)

m1 <- vglm(dicb~dosevecb+dosevecb2, family = pospoisson(),data=datavecC1)


DM<-as.matrix(data.frame(1,datavecC1[,2:3]))

cm1a<-coefficients(m1)

cm1<-exp(DM%*%cm1a)
X<-dic

XO<-length(X[X==0])

h<-f(mod$fitted.values)
mfv<-dpois(0,mod$fitted.values*h+cm1*(1-h))##for Poisson model

1-ppoibin(XO,mfv)

QI<-qpoibin(c(0.05,0.95),pp=mfv)

####determining the MQI###
lower<-QI[2]-1
upper<-QI[2]

aa<-ppoibin(upper,mfv)
bb<-ppoibin(lower,mfv)

k<-(0.95-aa)/(bb-aa)

a1<-k*lower+(1-k)*upper ##the upper limit of MQI


lower<-QI[1]-1
upper<-QI[1]

aa<-ppoibin(upper,pp=mfv)
bb<-ppoibin(lower,pp=mfv)

k<-(0.05-aa)/(bb-aa)

a2<-k*lower+(1-k)*upper


c(a2,a1) ## is the MQI
