library(gamlss)
library(VGAM)
library(poibin)

f<-function(t)  ifelse(t<2.07,0.7*(0.85^t),0.5)

####Martin Ridout's function####
h1<-function(t)  t*(1-exp(1/t-t))
h2a<-function(t)  t*(1-exp(-h1(t)))^2-(h1(t))^2*exp(-h1(t))
h2b<-function(t)  1-(h1(t)+1)*(exp(-h1(t)))

h2<-function(t)   h2a(t)/h2b(t)
###################################################

#Trajan<-read.table(file.choose(),sep=",", header=TRUE)
head(Trajan)
Trajan2<-data.frame(1,as.factor(Trajan$PERIOD))

y1<-Trajan$NSHOOTS
n0<-length(y1[y1==0])
#y1<-rpois(n,0.4)
y<-y1[y1>0]

TrajanP<-data.frame(y,as.factor(Trajan$PERIOD[y1>0]))

data<-as.matrix(data.frame(1,Trajan$PERIOD))

m1 <- vglm(y ~ as.factor(Trajan$PERIOD[y1>0]), family = pospoisson(), data=TrajanP)



mut1<-fitted(m1)[1]
mut2<-fitted(m1)[141]
mut<-c(rep(mut1,140),rep(mut2,130))
modz<-gamlss(y1~as.factor(Trajan$PERIOD),sigma.fo=~as.factor(Trajan$PERIOD),family=ZIP,trace=FALSE)
g<-function(t1,t2) dZIP(0,t1,t2)

mfvz<-mapply(FUN=g,modz$mu.fv,modz$sigma.fv)

#mod2<-gamlss(y1~1,family=ZIP)
#print(cm1)
#print(mod$mu.fv[1])
#print(mod2$mu.fv[1])


modp<-glm(y1 ~ Trajan$PERIOD, family = poisson())
muw<-modp$fitted.values
a<-f(muw)
mu<-a*muw+(1-a)*mut

mfv<-exp(-mu)

pvaluepois<-0.5*(1-ppoibin(n0,pp=mfv)+1-ppoibin(n0-1,pp=mfv))

QI<-qpoibin(c(0.025,0.975),pp=mfv)


####determining the MQI###
lower<-QI[2]-1
upper<-QI[2]

aa<-ppoibin(upper,mfv)
bb<-ppoibin(lower,mfv)

k<-(0.975-aa)/(bb-aa)

a1<-k*lower+(1-k)*upper ##the upper limit of MQI

##The lower limit is 0 by definition of MQI
## (Though this is debatable!!)

####################PERIOD=16###########################



Trajan16<-Trajan[141:270,]
y1<-Trajan16$NSHOOTS
y<-y1[y1>0]
n<-length(y)
n0<-length(y1[y1==0])

muw<-mean(y1)
mut<-h2(mean(y))
h<-f(muw)

mu<-h*muw+(1-h)*mut
h<-2/3
mu<-h*muw+(1-h)*mut

mfv<-dpois(0,mu)
pois<-0.5*(1-pbinom(n0,n,mfv)+1-pbinom(n0-1,n,mfv))

QI<-qbinom(c(0.05,0.975),n,mfv)


####determining the MQI###
lower<-QI[2]-1
upper<-QI[2]

aa<-pbinom(upper,n,mfv)
bb<-pbinom(lower,n,mfv)

k<-(0.975-aa)/(bb-aa)

a1<-k*lower+(1-k)*upper ##the upper limit of MQI

##The lower limit is 0 by definition of MQI
## (Though this is debatable!!)

#######################PERIOD =8######

Trajan8<-Trajan[1:140,]
y1<-Trajan8$NSHOOTS
y<-y1[y1>0]
n<-length(y)
n0<-length(y1[y1==0])

muw<-mean(y1)
mut<-h2(mean(y))
h<-f(muw)

mu<-h*muw+(1-h)*mut


mfv<-dpois(0,mu)
pois<-0.5*(1-pbinom(n0,n,mfv)+1-pbinom(n0-1,n,mfv))

QI<-qbinom(c(0.05,0.95),n,mfv)


####determining the MQI###
lower<-QI[2]-1
upper<-QI[2]

aa<-pbinom(upper,n,mfv)
bb<-pbinom(lower,n,mfv)

k<-(0.95-aa)/(bb-aa)

a1<-k*lower+(1-k)*upper ##the upper limit of MQI

##The lower limit is 0 by definition of MQI
## (Though this is debatable!!)


